<?php

/**
 *
 *   TMN chat, v1
 *   (c) Fosfor, 2010, fosfor.software@seznam.cz
 *   http://www.fosfor.cz/tmn/
 *
 *     pouziti:
 *
 *       zakladni zobrazeni:
 *         http://www.server.cz/chat.php
 *
 *       zakladni zobrazeni se vpisovanim (pokud je povoleno):
 *         http://www.server.cz/chat.php?write_password=heslo2
 *
 *       zobrazeni uvnitr stranky (bez HTML ohraniceni):
 *         http://www.server.cz/chat.php?emb=true
 *
 *       zobrazeni uvnitr stranky (bez HTML ohraniceni) se vpisovanim (pokud je povoleno):
 *         http://www.server.cz/chat.php?emb=true&write_password=heslo2
 *
 *
 *    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 *      Pozor! Pouzivani hesla pro vpisovani neni bezpecne!
 *      Davejte si pozor, kde takovou stranku otevirate!
 *
 *    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 *
 */



// init

function catchError($errno, $errstr, $errfile, $errline){
  echo("<p><font color='red'>$errstr (line:$errline)</font></p>");
}
set_error_handler('catchError');

header('Content-Type: text/html; charset=utf-8');
require_once('config.php');
require_once('./inc/GbxRemote.inc.php');
require_once('./inc/tmfcolorparser.inc.php');

$cp = new TMFColorParser();
$admin = false;
if ($config['write'] && isset($_GET['write_password']) && ($_GET['write_password'] == $config['write_password']))
	$admin = true;
$emb = false;
if (isset($_GET['emb']) && ($_GET['emb'] == 'true'))
	$emb = true;

// init client

$client = new IXR_Client_Gbx();
if (!$client->InitWithIp($config['server'], $config['port'])) {
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
}
if (!$client->query("Authenticate", $config['name'], $config['password']))
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());

// send chat

if(isset($_POST['chatText']) && $admin)
	if (!$client->query('ChatSend', urldecode($_POST['chatText'])))
		trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());

// get chat

if (!$client->query('GetChatLines'))
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
$chat = $client->getResponse();
$chatAll = '';
foreach ($chat as $line)
	$chatAll .= $cp->toHTML(htmlspecialchars($line)).'<br>'.PHP_EOL;

// get players

if (!$client->query('GetPlayerList', 64, 0))
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
$players = $client->getResponse();
$playersAll = '';
foreach ($players as $player)
	$playersAll .= $cp->toHTML(htmlspecialchars($player['NickName'])).'<br>'.PHP_EOL;

// get map

if (!$client->query('GetCurrentChallengeInfo'))
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
$map = $client->getResponse();
$map = $cp->toHTML(htmlspecialchars($map['Name']));

// dinit

$client->Terminate();

if (!$emb) {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
	<title><?php echo $config['title']; ?></title>
	<meta name="generator" content="EditPlus">
	<meta name="author" content="Aaka Fosfor; FOSFOR software; fosfor.software@seznam.cz; 2010">
	<meta http-equiv="refresh" content="<?php echo $config['refresh']; ?>">
</head>
<?php
	if ($admin)
		echo '<body onload="document.getElementById(\'chatText\').focus();" style="background-color: #838383;">';
	else
		echo '<body style="background-color: #838383;">';
}
?>
	<div style="margin: auto; margin-top: 50px; text-align: center; width: 1000px;">
		<div style="text-align: center; border: solid white 2px; margin: 10px; padding: 10px;">
			<?php echo $map; ?>
		</div>
		<div style="text-align: left; float: right; width: 170px; border: solid white 2px; margin: 10px; padding: 10px; margin-top: 0px;">
			<?php echo $playersAll; ?>
		</div>
		<div style="text-align: left; width: 750px; border: solid white 2px; margin: 10px; padding: 10px;">
			<?php echo $chatAll; ?>
		</div>
<?php if ($admin) { ?>
		<div style="text-align: left; border: solid white 2px; margin: 10px; padding: 10px;">
			<form action="" method="post">
				<p>
					Poslat zprávu:<br>
					<input type="text" name="chatText" size="100" id="chatText" style="background-color: #737373; border: solid white 1px; color: white;">
					<input type="submit" value="Odeslat" style="background-color: #737373; border: solid white 1px; color: white;">
				</p>
			</form>
		</div>
<?php } ?>
		<input type="button" value="Zavřít okno" onclick="window.close();" style="background-color: #737373; border: solid white 1px; color: white;">
	</div>
<?php
if (!$emb)
	echo '</body></html>';
?>